/*
	LPS Example

	Routine 3

	Language: C89
 	Style: plain C
 	Version: Ref-pc
 */

/*
	Original Plain C Code
*/

/*
  Questo esempio illustra la traduzione in ASM di un programma C89
	che contiene un prototipo e in cui avvengono conversioni
	di tipo nella chiamata di una funzione.
  Vengono realizzate 2 traduzioni:
	1) traduzione corretta, grazie alla presenza del prototipo
	2) traduzione del programma C89 da cui viene rimosso il prototipo:
		si usa la regola della dichiarazione implicita, che in
		questo caso provoca un undefined behavior in quanto induce 
		il traduttore ad applicare delle conversioni di dato errate
*/

#include <stdio.h>

/* Prototipo */
int f( long a, long b );

/* Main */
int main( void ) {

	long x, z;
	int y = -99;

	scanf( "%ld", &x );

	z = f( x, y );
	
	printf( "%ld", z );

	return 0;
}

/* Definizione di f */
int f( long a, long b ) {
	a += b;
	return a / 1000;
}

/*
	Test Cases, prototipo presente (programma corretto)

	Test 1
	input: 100005
	output: 99

	Test 2
	input: -2000
	output: -2

	Test 3
	input: -2901
	output: -3

	Test 4
	input: 99999
	output: 99
*/

/*
	Test Cases, prototipo assente (programma non corretto)

	Test 1
	input: 100005
	output: 4295067

	Test 2
	input: -2000
	output: 4294965

	Test 3
	input: -2901
	output: 4294964

	Test 4
	input: 99999
	output: 4295067
*/
